#ifndef  _PDR_BASE_H_
#define  _PDR_BASE_H_

#include <stdint.h>

#define ACCURACY_ERR_MAX                    1000                 // GPSaccuracyֵ,һڳʼ
#define N                                   4                    // ά
#define MAX_NO_GPS_PREDICT                  10		             // GPSϢ״̬λ	
#define IMU_SENSOR_AXIS                     3                    // IMUĬ3
// û˶ʶ
#define DETECTOR_TYPE_STATIC                0                    // ûֹ 
#define DETECTOR_TYPE_IRREGULAR             1                    // ޹˶
#define DETECTOR_TYPE_HANDHELD              2                    // ֳ˶
#define DETECTOR_TYPE_SWINGING              3                    // ˶
#define DETECTOR_NO_ERROR                   0

#define TYPE_FIX_NONE                       0

#define PDR_TRUE                            1
#define PDR_FALSE                           0
#define NO_UPDATE                           0

typedef struct {
	double Xk[N];             // ϵͳ״̬  xk[0]: x  xk[1]y  xk[2]  xk[3] 
	double pXk[N];            // Ԥ  xk[0]: x  xk[1]y  xk[2]  xk[3] 
	double Zk[N];
	double pPk[N][N];
	double Pk[N][N];
	double Phi[N][N];
	double hk[N][N];
	double Q[N][N];           // ˲Q()
	double R[N][N];           // ˲R(۲)
	double Kk[N][N];
	double Lambda;
	double pLat;
	double pLon;
	double initHeading;       // ʼ
}EKFPara_t;

typedef struct Sensor {
	uint8_t update;
	int     type;
	double  time;
	float   s[IMU_SENSOR_AXIS];
}Sensor_t;

typedef struct IMU {
	Sensor_t acc;
	Sensor_t gyr;
	Sensor_t mag;
}IMU_t;

// û˶ͷ
typedef struct DETECTOR {
	uint32_t type;                              // û˶  0:ֹ˶ 1޹˶ 2ֳ˶ 3˶
	uint32_t lastType;
	uint64_t tick;                              // ͳƣڵƵ
}Detector_t;


typedef struct PDR {
	uint32_t        Status;                     // PDRǰ״̬
	uint32_t        MotionType;                 // û˶
	// ٶ
	double          GnssSpeed;                  // GNSSٶ
	double          Heading;                    // 
	// 
	uint64_t        Steps;                      // ǰϢ
	uint64_t        LastSteps;                  // һεĲ
} PDR_t;

typedef struct AHRS {
	uint8_t status;
	uint8_t stable;                             // ǰAHRS㷨ȶ
	float error;
	float q[4];                                 
	float gravity[3];
	float x_axis[3];
	float y_axis[3];
	float z_axis[3];
	float Dt;
	float Kp;                                   // mahony kpڲ
	float Yaw;
	float Pitch;
	float Roll;
	float insHeading;
}AHRS_t;

typedef struct {
	uint8_t Update;
	double  MinTime;
	double  MaxTime;
}Nmea_t;


typedef struct {
	//LL_NSEW latitude_ns;
	//LL_NSEW longitudinal_ew;
	double latitude;
	double longitudinal;
	double gpsLat;
	double gpsLon;
	double gpsHeading;
	double pdrHeading;
	double hdop;
	double gpsSpeed;
	double accuracy;
	double time;
	double yaw;
	double lambda;
	double last_lat;
	double last_lon;
	unsigned long step;
	uint8_t motionType;
}LctFs_t;

#endif // ! _PDR_BASE_H
